<?
/*
 * Plugin Name: Last.fm RPS
 * Plugin URI: http://www.tahapaksu.com/wordpress/lastfm-wordpress-plugin
 * Description: Display Recently Played Songs and Album Art from Last.fm. Just activate the plugin, Add a widget it Design->Widgets and insert your last.fm username in widget settings.
 * Version: 0.5
 * License: Free to Use
 * Author: Taha Paksu
 * Author URI: http://www.tahapaksu.com/
 */


include "simplexml.class.php";

function get_album_art($album,$artist){
	$plugindir = get_option('siteurl') . '/wp-content/plugins/' . dirname(plugin_basename(__FILE__));
	$url = "http://ws.audioscrobbler.com/1.0/album/".urlencode(utf8_encode($artist))."/".urlencode(utf8_encode($album))."/info.xml";
	$sx = new simplexml;
	$feed = $sx->xml_load_file($url);
	if($feed->coverart->small) return $feed->coverart->small;
	if($feed->coverart->medium) return $feed->coverart->medium;
	if($feed->coverart->large) return $feed->coverart->large;
	return $plugindir."/noart.gif";
}

function lastfm_datediff($date,$ret = 0,$serversec,$recentdisplayed){
$now = time();
$dateDiff = $now - $date + $serversec;
$fullDays = floor($dateDiff/(60*60*24));
$fullHours = floor(($dateDiff-($fullDays*60*60*24))/(60*60));
$fullMinutes = floor(($dateDiff-($fullDays*60*60*24)-($fullHours*60*60))/60);
if($fullDays)	return "$fullDays"."d,$fullHours"."h and $fullMinutes"."m ago";
if($fullHours) return "$fullHours"."h,$fullMinutes"."m ago";
if($fullMinutes>=4) return "$fullMinutes minutes ago";
if($recentdisplayed) return "$fullMinutes minutes ago";
if($ret) return "recent";
return "just listened";
}


function lastfm_recent_death($message){
	echo "<ul id=\"lastfm_recent_ul\">";
	echo '<li class="lastfm_recent_li" style="clear:both;min-height:53px !important;">';
	echo $message;
	echo '</li>';
	echo "</ul>";
}

function lastfm_recent_capitalize($string){
	$string = preg_split("/ /",$string);
	for($i=0;$i<count($string);$i++)
		$string[$i] = strtoupper(substr($string[$i],0,1)) . substr($string[$i],1);
	return implode(" ",$string);
}


function lastfm_recent($user,$size,$timediff){
	$plugindir = get_option('siteurl') . '/wp-content/plugins/' . dirname(plugin_basename(__FILE__));
	if(!$_SESSION["lastfm_wp_head_exists"]) echo '<style type="text/css">@import url("'.$plugindir.'/lastfm.css");</style>'."\n";
	$url = "http://ws.audioscrobbler.com/1.0/user/".$user."/recenttracks.xml";
	$sx = new simplexml;
	$feed = $sx->xml_load_file($url);
	$recentdisplayed=false;
	if(!is_object($feed))
		lastfm_recent_death("This username does not exist, or the feed service is down.");
	elseif(!array_key_exists("track", get_object_vars($feed)))
		lastfm_recent_death("This user has not played any songs yet.");
	elseif(is_object($feed->track)){
		echo "<table class=\"lastfm_recent_table\" cellspacing=0 cellpadding=0>";
			$artist = $feed->track->artist->content();
			$date = $feed->track->date->attributes();
			$album = $feed->track->album->content();
			$tdimgclass = "lastfm_recent_td_img";
			$tdcontentclass = "lastfm_recent_td_content";
			if(lastfm_datediff($date->uts,true,$timediff,$recentdisplayed)=="recent"){
				$tdimgclass .= " lastfm_recent_recent";
				$tdcontentclass .= " lastfm_recent_recent";
				$recenthandler = true;
			}
			echo '<tr><td class="'.$tdimgclass.'">';
			echo '<a class="lastfm_recent_img_a" href="'.$feed->track->url.'">';
			echo '<img src="'.get_album_art($album->scalar,$artist->scalar).'" alt="Cover artwork for '.stripslashes(lastfm_recent_capitalize($album->scalar)).'" title="Cover artwork for '.stripslashes(lastfm_recent_capitalize($album->scalar)).'" class="lastfm_recent_img"/>';
			echo '</a></td><td class="'.$tdcontentclass.'">';
			echo '<a href="'.$feed->track->url.'" class="lastfm_recent_title">'.stripslashes(lastfm_recent_capitalize($feed->track->name)).'</a>';
			echo '<span class="lastfm_recent_artist">'.$artist->scalar.'</span><br />';
			echo '<span class="lastfm_recent_date">'.lastfm_datediff($date->uts,false,$timediff,$recentdisplayed).'</span>';
			echo '</td></tr>';
		echo "</table>";
		echo "<!--# Last.fm Recently Played Songs Plugin by Taha Paksu -->";
	}else{
		$k=0;
		echo "<table class=\"lastfm_recent_table\" cellspacing=0 cellpadding=0>";
		foreach($feed->track as $track){
			$artist = $track->artist->content();
			$date = $track->date->attributes();
			$album = $track->album->content();
			$tdimgclass = "lastfm_recent_td_img";
			$tdcontentclass = "lastfm_recent_td_content";
			if(lastfm_datediff($date->uts,true,$timediff,$recentdisplayed)=="recent"){
				$tdimgclass .= " lastfm_recent_recent";
				$tdcontentclass .= " lastfm_recent_recent";
				$recenthandler = true;
			}
			echo '<tr><td class="'.$tdimgclass.'">';
			echo '<a class="lastfm_recent_img_a" href="'.$track->url.'">';
			echo '<img src="'.get_album_art($album->scalar,$artist->scalar).'" alt="Cover artwork for '.stripslashes(lastfm_recent_capitalize($track->name)).'" class="lastfm_recent_img"/>';
			echo '</a></td><td class="'.$tdcontentclass.'">';
			echo '<a href="'.$track->url.'" class="lastfm_recent_title">'.stripslashes(lastfm_recent_capitalize($track->name)).'</a>';
			echo '<span class="lastfm_recent_artist">'.$artist->scalar.'</span><br />';
			echo '<span class="lastfm_recent_date">'.lastfm_datediff($date->uts,false,$timediff,$recentdisplayed).'</span>';
			echo '</td></tr>';
			$k++;
			if($recenthandler) $recentdisplayed = true;
			if($k==$size) break;
		}
		echo "</table>";
		echo "<!--# Last.fm Recently Played Songs Plugin by Taha Paksu -->";
	}
}

add_action('wp_head', 'lastfm_recent_load_css');
function lastfm_recent_load_css(){
	$plugindir = get_option('siteurl') . '/wp-content/plugins/' . dirname(plugin_basename(__FILE__));
	echo '<link rel="stylesheet" href="'.$plugindir.'/lastfm.css" type="text/css"/>'."\n";
	$_SESSION["lastfm_wp_head_exists"] = true;
}


function lastfm_recent_widget($args) {
	extract($args);
	$options = get_option("lastfm_recent");
	if (!is_array( $options ))
	{
		$options = array(
		'title' => 'Last.fm RPS',
		'size' => 10,
		'serversec' => 0
		);
	}      
	if(!$options["size"]) $options["size"]=10;
	echo $before_widget;
		echo $before_title;
			echo $options['title'];
	    echo $after_title;
	if(!$options["user"]){
	lastfm_recent_death("Widget options not set. Please go to Admin->Design->Widgets to adjust the settings.");
	}else
    lastfm_recent($options["user"],$options["size"],$options['serversec']);
	echo $after_widget;
}

function lastfm_recent_control() 
{
  $options = get_option("lastfm_recent");
  
  if (!is_array( $options ))
	{
		$options = array(
      'user' => '',
	  'title' => 'Last.fm RPS',
	  'size' => 10,
	  'serversec' => 0
      ); 
  }      
  
  if ($_POST['lastfm_recent_submit']) 
  {
    $options['user'] = htmlspecialchars($_POST['lastfm_recent_user']);
	$options['title'] = htmlspecialchars($_POST['lastfm_recent_title']);
	$options['size'] = htmlspecialchars($_POST['lastfm_recent_size']);
	$options['serversec'] = htmlspecialchars($_POST['lastfm_recent_serverdiff']);
    update_option("lastfm_recent", $options);
  }
  
?>
  <p>
  <TABLE>
  <TR>
	<TD>Widget Title: </TD>
	<TD><input type="text" id="lastfm_recent_title" name="lastfm_recent_title" value="<?php echo $options['title'];?>" /></TD>
  </TR>
  <TR>
	<TD>Last.fm Username:</TD>
	<TD><input type="text" id="lastfm_recent_user" name="lastfm_recent_user" value="<?php echo $options['user'];?>" /><input type="hidden" id="lastfm_recent_submit" name="lastfm_recent_submit" value="1" /></TD>
  </TR>
    <TR>
	<TD>List size: </TD>
	<TD><select name="lastfm_recent_size"><?php for($i=1;$i<11;$i++){ ?><option value="<?=$i?>" <?php if($i==$options["size"]) echo "selected";?>><?=$i?></option><?php }?></TD>
	</TR>
    <TR>
	<TD valign=top>Server time difference: </TD>
	<TD><input type="text" id="lastfm_recent_user" name="lastfm_recent_serverdiff" value="<?php echo $options['serversec'];?>" /><br /> <small>Date difference in seconds with your server and local time (Now is <?php echo date("H:i:s",time());?> for your server)</small></TD>
	</TR>
  </TABLE>

  </p>
<?php
}

function lastfm_recent_sidebar($user=false,$size=10,$serversec=0){
	if(!$user){
	lastfm_recent_death("Username not set. Please check your code.");
	}else{
    lastfm_recent($user,$size,$serversec);
	}
}


function lastfm_recent_init()
{
  register_sidebar_widget(__('Last.fm RPS'), 'lastfm_recent_widget');
  register_widget_control(   'Last.fm RPS', 'lastfm_recent_control', 300, 200 );     
}
add_action("plugins_loaded", "lastfm_recent_init");
?>